package RNDGui;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;
import javax.swing.text.BadLocationException;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StackedXYBarRenderer;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import edu.emory.mathcs.jtransforms.fft.DoubleFFT_1D;

import FTInterface.*;


import java.awt.BorderLayout;
import java.io.IOError;
import java.io.IOException;
import java.util.LinkedList;
public class RNDUI extends JFrame{

public static FTManager FTIO=new FTManager();

static IOInterface xf=new IOInterface();//instance of the interface
	
private static final long serialVersionUID = -1251802282016321436L;

final static XYSeries vals = new XYSeries("X");
final static XYSeriesCollection valSet = new XYSeriesCollection();
final static XYSeries ffts = new XYSeries("X");
final static XYSeriesCollection fftSet = new XYSeriesCollection();
static LinkedList<Byte> fifo = new LinkedList<Byte>();

static long n=0;

public RNDUI() {

	setLocation(20, 20);
	setSize(300, 300);
	setTitle("Random generator");
	setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	//new DemoLotto();
	
	initGUI();
}

private void initGUI() {
	
	GridLayout experimentLayout = new GridLayout(0,3);
	JPanel Paanel = new JPanel();
	JPanel Panel = new JPanel(new GridLayout(200, 200, 0, 0));
	JPanel Panel2 = new JPanel(new GridLayout(200, 200, 0, 0));
	getContentPane().add(Paanel, BorderLayout.NORTH);
	Paanel.setLayout((LayoutManager) new BoxLayout(Paanel, BoxLayout.Y_AXIS));
	Panel.setLayout(experimentLayout);
	Panel2.setLayout(experimentLayout);
	
	//JButton lwin = new JButton("Lottery demo");
	
	Paanel.add(Panel2);
	Paanel.add(Panel);

	valSet.addSeries(vals);
	
	final JFreeChart magChart = ChartFactory.createXYLineChart(
			"200x in data", // Title
			 "Time", // x-axis Label
			 "Value", // y-axis Label
			 valSet, // Dataset
			 PlotOrientation.VERTICAL, // Plot Orientation
			 false, // Show Legend
			 true, // Use tooltips
			 false // Configure chart to generate URLs?
			 );

    final XYPlot magPlot = magChart.getXYPlot();
    
    magPlot.getRenderer().setSeriesPaint(0, Color.GREEN);
    
    magPlot.setBackgroundPaint(Color.BLACK);
    magPlot.setDomainGridlinePaint(Color.WHITE);
    magPlot.setRangeGridlinePaint(Color.WHITE);
    magChart.setBackgroundPaint(Color.getHSBColor((float)0.0, (float)0.0, (float)0.933333));
    magChart.setBorderPaint(Color.GRAY);
    magPlot.setOrientation(PlotOrientation.VERTICAL);
    
    final ChartPanel magChartPanel = new ChartPanel(magChart);
    magChartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
    
    //dodaj u frame
    Paanel.add(magChartPanel);

    
    fftSet.addSeries(ffts);
    final JFreeChart fftChart = ChartFactory.createXYLineChart(
			"Spectrum (FFT)", // Title
			 "Frequency", // x-axis Label
			 "Amplitude", // y-axis Label
			 fftSet, // Dataset
			 PlotOrientation.VERTICAL, // Plot Orientation
			 false, // Show Legend
			 true, // Use tooltips
			 false // Configure chart to generate URLs?
			 );

    final XYPlot fftPlot = fftChart.getXYPlot();
    
    
    fftPlot.getRenderer().setSeriesPaint(0, Color.RED);

     fftPlot.setBackgroundPaint(Color.BLACK);
    fftPlot.setDomainGridlinePaint(Color.WHITE);
    fftPlot.setRangeGridlinePaint(Color.WHITE);
    fftChart.setBackgroundPaint(Color.getHSBColor((float)0.0, (float)0.0, (float)0.933333));
    fftChart.setBorderPaint(Color.GRAY);
    fftPlot.setOrientation(PlotOrientation.VERTICAL);
    
    final ChartPanel fftChartPanel = new ChartPanel(fftChart);
    magChartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
    
    //dodaj u frame
    Paanel.add(fftChartPanel);
    
    //Paanel.add(new JScrollPane(lwin));

	/*lwin.addActionListener(new ActionListener() {
		
		@Override
		public void actionPerformed(ActionEvent e) {
			DemoLotto.Visibility(true);
		}
	});*/
	
	
	this.getContentPane().add(new JScrollPane(), "Center");
		
		this.pack();
	}
	
	public static void main(String[] args) {
		
		SwingUtilities.invokeLater(new Runnable() {	
			@Override
			public void run() {
	
				
				JFrame win = new RNDUI();
				win.setVisible(true);
			}
		});
		
		new Thread(new RndBuffer()).start();
		int t=50,fn=0,fi=0;
		byte r=0,b;
		double[] input=new double[1000000];
		double fres;
		DoubleFFT_1D fftDo;
		
		while(true){
			if(fifo.size()>200){
				for(short j=0;j<200;j++){
					r^=b=fifo.getFirst();
					input[fi++]=b;
					fifo.removeFirst();
				}

				vals.add(n++,r);
				if(n>99)vals.remove(n-100);
			}
			try {Thread.sleep(5+t);} catch (InterruptedException e) {}
			if(fifo.size()>10000&&t>1)t--;
			if(fifo.size()<20)t++;
			if(fi>10000){
				fftDo = new DoubleFFT_1D(fi);
		        double[] fft = new double[fi * 2];
		        System.arraycopy(input, 0, fft, 0, fi);
		        fftDo.realForwardFull(fft);
		        fn=fi=0;
		        
				ffts.clear();
				fres=0;
				int dco=0;
		        for(double d: fft) {
		        	if(dco>99){
		        		
		        		ffts.add(fn++,fres/100);
		        		fres=dco=0;
		        	}
		        	else
		        		fres+=d;
		        	dco++;
		            
		        }
	        }
			
		}
	}
	
	public static byte getRND(){
		byte b = fifo.getFirst();
		fifo.removeFirst();
		return b;
	}
	
	private static class RndBuffer implements Runnable{
	
		@Override
		public void run() {
			
			while(true){
				try {
					fifo.add((byte) FTManager.jd.read());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

}
